/*
 =================== DO NOT EDIT THIS FILE ====================
 Generated by Modello 1.6 on 2013-09-12 14:35:43,
 any modifications will be overwritten.
 ==============================================================
 */

package org.sonatype.nexus.rest.model;

/**
 * REST Response object for a list of search results, contains the
 * typical 'data' parameter, which is a
 *         list of search results.
 * 
 * @version $Revision$ $Date$
 */
@SuppressWarnings( "all" )
@com.thoughtworks.xstream.annotations.XStreamAlias( value = "searchNGResponse" )
@javax.xml.bind.annotation.XmlRootElement( name = "searchNGResponse" )
@javax.xml.bind.annotation.XmlAccessorType(javax.xml.bind.annotation.XmlAccessType.FIELD)
        
public class SearchNGResponse
    extends NexusIndexerResponse
    implements java.io.Serializable
{

      //--------------------------/
     //- Class/Member Variables -/
    //--------------------------/

    /**
     * The grand total number of results found on index.
     */
    private int totalCount = 0;

    /**
     * The starting index of the results.
     */
    private int from = 0;

    /**
     * The number of results in this response.
     */
    private int count = 0;

    /**
     * Flag that states if too many results were found.
     */
    private boolean tooManyResults = false;

    /**
     * Flag that states if result set is collapsed, and shows
     * latest versions only.
     */
    private boolean collapsed = false;

    /**
     * Field repoDetails.
     */
    @javax.xml.bind.annotation.XmlElementWrapper( name = "repoDetails" )
    @javax.xml.bind.annotation.XmlElement( name = "repositoryDetail" )
    private java.util.List<NexusNGRepositoryDetail> repoDetails;

    /**
     * Field data.
     */
    @javax.xml.bind.annotation.XmlElementWrapper( name = "data" )
    @javax.xml.bind.annotation.XmlElement( name = "nexusNGArtifact" )
    private java.util.List<NexusNGArtifact> data;


      //-----------/
     //- Methods -/
    //-----------/

    /**
     * Method addData.
     * 
     * @param nexusNGArtifact
     */
    public void addData( NexusNGArtifact nexusNGArtifact )
    {
        getData().add( nexusNGArtifact );
    } //-- void addData( NexusNGArtifact )

    /**
     * Method addRepoDetail.
     * 
     * @param nexusNGRepositoryDetail
     */
    public void addRepoDetail( NexusNGRepositoryDetail nexusNGRepositoryDetail )
    {
        getRepoDetails().add( nexusNGRepositoryDetail );
    } //-- void addRepoDetail( NexusNGRepositoryDetail )

    /**
     * Get the number of results in this response.
     * 
     * @return int
     */
    public int getCount()
    {
        return this.count;
    } //-- int getCount()

    /**
     * Method getData.
     * 
     * @return List
     */
    public java.util.List<NexusNGArtifact> getData()
    {
        if ( this.data == null )
        {
            this.data = new java.util.ArrayList<NexusNGArtifact>();
        }

        return this.data;
    } //-- java.util.List<NexusNGArtifact> getData()

    /**
     * Get the starting index of the results.
     * 
     * @return int
     */
    public int getFrom()
    {
        return this.from;
    } //-- int getFrom()

    /**
     * Method getRepoDetails.
     * 
     * @return List
     */
    public java.util.List<NexusNGRepositoryDetail> getRepoDetails()
    {
        if ( this.repoDetails == null )
        {
            this.repoDetails = new java.util.ArrayList<NexusNGRepositoryDetail>();
        }

        return this.repoDetails;
    } //-- java.util.List<NexusNGRepositoryDetail> getRepoDetails()

    /**
     * Get the grand total number of results found on index.
     * 
     * @return int
     */
    public int getTotalCount()
    {
        return this.totalCount;
    } //-- int getTotalCount()

    /**
     * Get flag that states if result set is collapsed, and shows
     * latest versions only.
     * 
     * @return boolean
     */
    public boolean isCollapsed()
    {
        return this.collapsed;
    } //-- boolean isCollapsed()

    /**
     * Get flag that states if too many results were found.
     * 
     * @return boolean
     */
    public boolean isTooManyResults()
    {
        return this.tooManyResults;
    } //-- boolean isTooManyResults()

    /**
     * Method removeData.
     * 
     * @param nexusNGArtifact
     */
    public void removeData( NexusNGArtifact nexusNGArtifact )
    {
        getData().remove( nexusNGArtifact );
    } //-- void removeData( NexusNGArtifact )

    /**
     * Method removeRepoDetail.
     * 
     * @param nexusNGRepositoryDetail
     */
    public void removeRepoDetail( NexusNGRepositoryDetail nexusNGRepositoryDetail )
    {
        getRepoDetails().remove( nexusNGRepositoryDetail );
    } //-- void removeRepoDetail( NexusNGRepositoryDetail )

    /**
     * Set flag that states if result set is collapsed, and shows
     * latest versions only.
     * 
     * @param collapsed
     */
    public void setCollapsed( boolean collapsed )
    {
        this.collapsed = collapsed;
    } //-- void setCollapsed( boolean )

    /**
     * Set the number of results in this response.
     * 
     * @param count
     */
    public void setCount( int count )
    {
        this.count = count;
    } //-- void setCount( int )

    /**
     * Set list of found artifacts.
     * 
     * @param data
     */
    public void setData( java.util.List<NexusNGArtifact> data )
    {
        this.data = data;
    } //-- void setData( java.util.List )

    /**
     * Set the starting index of the results.
     * 
     * @param from
     */
    public void setFrom( int from )
    {
        this.from = from;
    } //-- void setFrom( int )

    /**
     * Set list of repositories artifacts found in.
     * 
     * @param repoDetails
     */
    public void setRepoDetails( java.util.List<NexusNGRepositoryDetail> repoDetails )
    {
        this.repoDetails = repoDetails;
    } //-- void setRepoDetails( java.util.List )

    /**
     * Set flag that states if too many results were found.
     * 
     * @param tooManyResults
     */
    public void setTooManyResults( boolean tooManyResults )
    {
        this.tooManyResults = tooManyResults;
    } //-- void setTooManyResults( boolean )

    /**
     * Set the grand total number of results found on index.
     * 
     * @param totalCount
     */
    public void setTotalCount( int totalCount )
    {
        this.totalCount = totalCount;
    } //-- void setTotalCount( int )

}
